require 'simple_struct'

class SimpleConfig
  class << self
    attr_writer :directory

    def directory 
      @directory ||= 'config'
    end

    attr_writer :default

    def default
      @default ||= :config
    end

    def method_missing method_name, *args
      if (File.exists?(full_file_name = full_file_name(method_name)))
        data(full_file_name)
      else
        data(full_file_name(@default)).send(method_name, *args)
      end
    end

    def full_file_name file_name
      File.join(@directory, "#{file_name}.yml")
    end
    private :full_file_name

    def data full_file_name  
      SimpleStruct.create(YAML.load_file(full_file_name))
    end
    private :data
  end
end
