require 'ostruct'

class SimpleStruct 

  def initialize hash
    @origin_hash = hash
    @a = hash.inject({}){ |res, (key, value)| res[key] = SimpleStruct.create(value); res }
  end

  def [](key)
    @a[real_key(key)]
  end

  def []=(key, value)
    @a[real_key(key)] = value
  end

  def to_hash
    @origin_hash
  end

  def method_missing method_name, *args
    return self[method_name.to_s.delete("=")] = args.first if method_name[-1] == "=" 
    return self[method_name] if @a.has_key?(real_key(method_name))

    super method_name, *args
  end

  def real_key key
    @a.keys.find { |k| k.to_s == key.to_s} || key
  end
  private :real_key 

  class << self 
    def create obj
      obj.is_a?(Hash) ? SimpleStruct.new(obj) : obj
    end
  end
end
